#!/usr/bin/perl
#
# $Id: eval_blast,v 1.1 2003/01/23 01:20:43 yuan Exp $
# (c) Yuan@embl.de, Bork Group, EMBL, Heidelberg
# 

use CGI qw(:standard);

new CGI;

#sub if_string_print($);

$| = 1;

my $echofilter = 0;
my $n          = "[0-9]";

my $oneline    = 0;
my $align      = 0;

my $q_name     = '';
my $l_query    = 0;
my $output     = '';
my $output1    = '';
  
my $head       = 1;
  
my $sid        = '';
my @query      = ();
my $score      =  0;
my @sbjct      = ();
my %length     = ();
my $ta         = '';
my $ta1        = '';
my $wgetz1     = '';

my $colortoggle=0;

while (<>) {
  

  if ($head && /^(\w*BLAST\w)(\s.*)/) {
    print start_html(-title  =>"MSBLAST result: @{[scalar localtime()]}",
                     -author =>'Yuan@embl.de',
                     -BGCOLOR=>'white',
                    );                      
    print "<pre>\n";
    print h3("MSBLAST Result"), "\n";
    print a({href=>"http://dove.embl.de/Blast2/msblast.html"}, 
            img({-src=>'http://www.bork.embl.de/Images/msblast.gif', -align=>'left', -border=>0}));
    print "   Yuan\@embl.de, Bork Group, EMBL, Heidelberg.  Jul. 2003\n\n";
	print hr, "\n";

    print b("$1"),$2, "\n";;  
    next;
  }
  elsif ($head && /^(Reference:)\s+(.*)/) {
    #print b("$1"), $2,"\n";
    print b("$1"), b(" 1. ") . $2,"\n";
    next;
  }
  elsif ($head && /^(Query=)(\s.*)/) {
    $q_name = $2;
    print b("$1"), $q_name,"\n";
    $echofilter++;
    next;
  }
  elsif ($head && /^(\s*\((\d+\,*\d*)\s+letters.*)/) {
    print $1,"\n"; 
    $l_query = $2;
    #print $l_query;   #OK.
  }
  elsif ($head && $echofilter && /^(>\w*.*)/) {
    print "\n",b("Echofilter:"),"\n$1\n";;
    $echofilter--;
  }
  elsif ($head && /^(Database:)(\s.*)/) {
    print b("$1"), $2,"\n";
    $echofilter-- if ($echofilter); # switch off 
    next;
  }
  elsif ($head && /^(\s*Observed Numbers of Database.*)/) {
    print b("Histogram:"),"\n\n", $1,"\n";
  }
  elsif ($head && /^<font color/){
	$colortoggle=$colortoggle+1;
	print $_;
  }
  elsif ($head && /^\s+(Smallest)$/ || /^\s+High\s+Total/) {
    # new
    # print start_form("POST", "http://www.bork.embl.de/cgi/getseq");
    print start_form("POST",
		     "http://dove.embl.de/cgi/getseq");

    #  print "<font color=#FF0000>Warning:</font> Due to SRS problems, the following option 'Get the selected sequences'", br, "might return wrong sequences to you. Please check the sequences with care.", br;  

    # new
    print b("Summary:"), 
          ' ' x 30,
          submit(-name=>'select',-value=>'Get the selected sequences'),
          ' ' x 5,
          reset,
          "\n",
          $_;
    #print b("Summary:"), "\n", $_;
  }
  elsif ($head && /^(\s*\/*\:*)((\w+)\|(\w+)\|(\S+))(.*)/) {
    my ($sid,$db,$acc,$id) = ($2,$3,$4,$5);
   
    my $wgetz = getz($db,$acc,$id) unless ($db eq "db");
    $oneline++;
    
    # Peer's opinion 22.01.97 -> using N as the crosslinks to the picture part

    print $1,
          a({name=>"_$^T\_$oneline"},"");
    unless ($db eq "db") {
        print a({href=>"$wgetz"},"$sid") ;
    }
	else {
		print "$sid";
	}

    #Accurate up until here.  Errors introduced in the parsing of rest
    #as its format has changed. - Jeff

    #This is all of the line after the id section
    my $rest = $6;

    #Lets go get the numbers as we expect them
    $rest =~ /(.*)(\s+)(\d+)(\s+)(\d+)$/;

    print $1,$2, a({href=>"#$^T\_$oneline"},$3),$4,a({href=>"#$^T\_p$oneline"},$5);
    if ($colortoggle == 1) {
      print checkbox_group(-name=>'seq',
			   -values=>["$db|$acc|$id"],
			   -nolabels=>1,
			   -checked=>'checked');
    }
    else {
      print checkbox_group(-name=>'seq',
			   -values=>["$db|$acc|$id"],
			   -nolabels=>1);
    }
    print "\n";
    #Fix until Here (Hopefully) - Jeff
  }
  elsif ($head && $oneline && /^$/ ) {
    # new 
    print p,
          submit(-name=>'select',-value=>'Get the selected sequences'),
          ' ' x 5,
          reset,
          end_form,
          hr;

    # unset $oneline
    # undef $oneline;
    # $head undefined -> all lines from the time on will be stored into $output.
    undef $head;
    
    # print just this empty file.
    print $_,"\n";
    
    # this part conserved for pseudo-pic.
    print b("Query sequence and locally-aligned HSPs from database sequences"),"\n\n";
    
    # print out the first scalar of the query sequence
    #chop $q_name if ($q_name =~ /\n/);
    #my $a = ' ' x 4 . sprintf("%-20.20s",$q_name) . '  |';
    my $a = ' ' x 1 . sprintf("%-20.20s",$q_name) . '  |';
    print p_scalar($l_query);
    $a =~ s/\n/ /g; $a =~ s/\cM/ /g;
    print $a;
    print ' ', '_' x 50,"\n";
  }
  elsif (/^(WARNING:)(\s*Descriptions of (\d+).*)/) {
    $output .= b("$1") . $2 . "\n";
  }
  elsif (/^(\>\/*\:*)((\w+)\|(\w+)\|(\S+))(.*)/) {
    my $lsid = $2;
    my ($db,$acc,$id) = ($3,$4,$5);
      
    my $wgetz = getz($db,$acc,$id) unless ($db eq "db");
    
    $align++;
    
    unless ($sid) {
	  unless ($db eq "db") {
        $output .= a({name=>"$^T\_$align"},"") . a({href=>"#_$^T\_$align"},"^") . " " . a({href=>"#$^T\_p$align"},"=") . " ". a({href=>"$wgetz"},"$lsid") . $6 . "\n";
	  }
	  else {
        $output .= a({name=>"$^T\_$align"},"") . a({href=>"#_$^T\_$align"},"^") . " " . a({href=>"#$^T\_p$align"},"=") . " ". $lsid . $6 . "\n";

	  }
    }
    else {
	  unless ($db eq "db") {
        $output1 .= a({name=>"$^T\_$align"},"") . a({href=>"#_$^T\_$align"},"^") . " " . a({href=>"#$^T\_p$align"},"=") . " ". a({href=>"$wgetz"},"$lsid") . $6 . "\n";
	  }
	  else {
        $output1 .= a({name=>"$^T\_$align"},"") . a({href=>"#_$^T\_$align"},"^") . " " . a({href=>"#$^T\_p$align"},"=") . " ". $lsid . $6 . "\n";

	  }
    }
    
    if ($sid) {
      # change of the blocks of alignments
      unless ($sid eq $lsid) {
	#$ta = sprintf("%-21.21s",$sid);
	$ta = sprintf("%-18.18s",$sid);
	  
	unless ($db eq "db") {
	  $ta = a({name=>"$^T\_p@{[$align-1]}"},"") . a({href=>"#_$^T\_@{[$align-1]}"},"^") .' '. a({href=>"#$^T\_@{[$align-1]}"},"v") . ' ' . a({href=>"$wgetz1"},"$ta") . ' |';
	}
	else {
	  $ta = a({name=>"$^T\_p@{[$align-1]}"},"") . a({href=>"#_$^T\_@{[$align-1]}"},"^") .' '. a({href=>"#$^T\_@{[$align-1]}"},"v") . ' ' . $ta . ' |';

	}
	
	print $ta;
	print p_line($l_query, @query);
	@query = ();
	
	# output1 appending to output
	#my $a = sprintf("%-24.24s",$sid) . '  |';
	my $a = sprintf("%-21.21s",$sid) . '  |';
	$output .= &p_scalar($length{$sid}) . $a . ' ' . '_' x 50 . "\n";
	#$output .= sprintf("%-27.27s","Local hits (HSPs)         |") . &p_line($length{$sid}, @sbjct) . "\n";
	$output .= sprintf("%-24.24s","Local hits (HSPs)      |") . &p_line($length{$sid}, @sbjct) . "\n";
	
	$output .= $output1;
	@sbjct = ();
	$output1 = '';
      }
    }
    
    #$ta1 = sprintf("%-21.21s",$lsid);
    $ta1 = sprintf("%-18.18s",$lsid);
    
	unless ($db eq "db") {
      $ta1 = a({name=>"$^T\_p$align"},"") . a({href=>"#_$^T\_$align"},"^") .' '. a({href=>"#$^T\_$align"},"v") . ' ' . a({href=>"$wgetz"},"$ta1") . ' |';
	}
	else {
      $ta1 = a({name=>"$^T\_p$align"},"") . a({href=>"#_$^T\_$align"},"^") .' '. a({href=>"#$^T\_$align"},"v") . ' ' . $ta1 . ' |';

	}
      
    $wgetz1 = $wgetz;
    $sid = $lsid;
    undef %length if ($oneline != $align);
    $score = 0;
  }
  elsif ( $sid && /^\s+Length\s=\s(\d+\,*\d*)/ ) {
    my $t1 = $1; 
    $t1 =~ s/,//g;
    $length{$sid} = $t1; 
    $output .= $_;
  }
  elsif ( $sid && /^(\s+Score\s=.*)/ ) {
    $output1 .= $1;
    $output1 .=  "\n";
    $score++;
  }
  elsif ( $sid && /^Query:\s+(\d+)\s\S+\s(\d+)/) {
    my ($t1,$t2,$t3) = ($1,$2); 
    if ($t1 > $t2 ) {
      $t3 = $t1; $t1=$t2; $t2=$t3;
    }
    
    if ( !@query ) {
      push @query, $t1, $t2;
    } 
    else {
      @query = query(\@query,$t1,$t2);
    }
    
    $output1 .= $_;
  }
  elsif ($sid && /^Sbjct:\s+(\d+)\s\S+\s(\d+)/) {
    my ($t1,$t2,$t3) = ($1,$2); 
    if ($t1 > $t2 ) {
      $t3 = $t1; $t1=$t2; $t2=$t3;
    }
    
    if ( !@sbjct ) {
      push @sbjct,$t1,$t2;
    }
    else {
      @sbjct = query(\@sbjct,$t1,$t2);
    }
    
    $output1 .= $_;
    
  }
  elsif ( /^(WARNING:)(.*)/ ) {
    if ($head) {
      print b("$1"), $2,"\n";
    }
    else {
      $output1 .=  b("$1") . $2 . "\n";
    }
  }
  elsif (/^(Parameters:.*)/) {   
    if ($sid) {
      # if ($oneline == $align) {  # wrong condition because $align <= $oneline (some not reported!)
      # print the last line in the Query <-> local HSPs picture
      print $ta1;
      print p_line($l_query, @query);
      
      # leading line for the alignment part
      print "\n\n",b("Alignments:"),"\n";
	
      # output1 appending to output
      #my $a = sprintf("%-24.24s",$sid) . '  |';
      my $a = sprintf("%-21.21s",$sid) . '  |';

      if (%length) {
	$output .= p_scalar($length{$sid}) . $a . ' ' . '_' x 50 . "\n";
	#$output .= sprintf("%-27.27s","Local hits (HSPs)         |") . p_line($length{$sid}, @sbjct) . "\n";
	$output .= sprintf("%-24.24s","Local hits (HSPs)      |") . p_line($length{$sid}, @sbjct) . "\n";
	$output .= $output1;
	@sbjct = ();
	$output1 = '';
	
	$output .= b("$1") . "\n";
	
	undef %length;
      }
    }
    else {
      print b("$_"),"\n";
    }
  }
  elsif ( /^(Statistics:.*)/ ) {
    if ($sid) {
      $output .= b("$1") . "\n" ;
    }
    else {
      print b("$1"),"\n";
    }
  }
  elsif ($head) {
    print;
  }
  elsif ( !%length || !$score ) {
    $output .= $_;
  }
  else {
    $output1 .= $_;
  }
  
  # last step
  if (eof) {
    print "<pre>\n"; 
    print $output;
    #print pre,"\n";
    print "</pre>\n";
  }
}


########################################
# Subroutines
#

# check the overlapping of the segments
# usage:
#   query(@query,$1,$2);
#
sub query {
  my ($s,$x,$y) = @_;
    
  my (@query,$i,$j,@t,$last);

  #@t = sort { $a <=> $b; } @$s if ( @$s );
  
  @t = @$s;

  $last = $t[$#t];
  
  if ($x <= $t[0] && $y >= $t[$#t]) {
    @query=();
    push @query, $x, $y;
    undef @t;
  }
  else {
    while ( ($i,$j) = @t ) {
      shift @t; shift @t;
      
      # as soon as $x or $y are input to @array, they should be undefined. valid for others, too.
      
      if ($x) {
	if ( defined $i && $x <= $i ) {
	  push @query, $x;
	  undef $x;
	  
	  if ( defined $i && $y < $i-1 ) {
	    push @query,$y,$i,$j;
	    undef $y; undef $i; undef $j;
	  }
	  elsif ( defined $j && defined $y && $y < $j ) {
	    push @query, $j;
	    undef $j; undef $y; undef $i;
	  }
	  else {		# $y > $j
	    #push @query, $y; # wring $y compare with other $i, $j
	    undef $i;
	  }
	  # else $y must not be undefined.
	}
	elsif ( defined $j && $x < $j+1 ) {
	  # threw $x
	  push @query, $i;
	  undef $x; undef $i;
	  
	  if (defined $y && $y < $j+1) {
	    push @query, $j;
	    undef $y; undef $j;
	  }
	}
	elsif ( defined $j && $x == $j+1 ) {
	  push @query, $i;
	  
	  if ($j == $last) {
	    push @query, $y;
	    undef $y;
	  }
	  
	  undef $i; undef $j; undef $x;
	}
	elsif ( defined $j &&  $x > $j+1 ) {
	  # decide for $i, $j
	  push @query, $i, $j;
	  
	  if ( $j == $last ) {
	    push @query, $x, $y;
	    
	    undef $x; undef $y;
	    undef $i; undef $j;
	  }
	  else {
	    undef $i;		# undef $j;
	  }
	  # $x and $y go to next round
	}
      }
      
      if ($y) {
	if ( defined $i && $y < $i-1 ) {
	  push @query, $y, $i, $j;
	  undef $y; undef $i; undef $j;
	}
	elsif ( defined $i && ($y == $i-1 || $y == $i)) {
	  # $y, $i are neighbours; delete them
	  undef $y; undef $i; 
	  
	  push @query, $j;
	  undef $j;
	}
	elsif ( defined $j && $y < $j+1 ) {
	  push @query, $j;
	  # threw $y
	  undef $y; undef $j; undef $i;
	}
	elsif ( defined $j && $y >= $j+1 ) {
	  # push @query, $y;
	  if ($j == $last ) {
	    push @query, $y;
	    undef $y;
	  }
	  undef $j;
	}
      }
      
      if (defined $i || defined $j) {
	push @query, $i if defined $i;
	undef $i;
	push @query, $j if defined $j;
	undef $j;
      }
    }
  }  
  
  @query;
}


#
# for db check and wgetz
#
sub getz {
  my ($db, $acc, $id) = @_;

  $db="swissprot" if ($db eq "swiss" or $db eq 'sp');
  $db="pir"       if ($db eq "pironly");
    
  my $wgetz = 'http://www.embl.de/srs5bin/cgi-bin/wgetz?-e+' . "[$db-acc:$acc]";
  if ($db eq "trembl" || $db eq "swissnew") {
    # $wgetz = 'http://www.embl-heidelberg.de/srs/srsc?' . "[$db-acc:$acc]&[$db-id:$id]";
    #$wgetz = 'http://www.embl-heidelberg.de/srs5bin/cgi-bin/wgetz?-e+' . "[$db-acc:$acc]|[$db-id:$id]";
    $wgetz = 'http://www.embl.de/srs5bin/cgi-bin/wgetz?-e+' . "[$db-id:$id]";
  }
  elsif ($db eq "embl") {
    $db = 'EMBL_SP_EMBLEST';
    $wgetz = 'http://www.embl.de/srs5bin/cgi-bin/wgetz?-e+' . "[{$db}-acc:$acc]";
  }
  elsif ($db eq "emnew") {
    $db = 'EMBLNEW_SP_EMBL';
    $wgetz = 'http://www.embl.de/srs5bin/cgi-bin/wgetz?-e+' . "[{$db}-acc:$acc]";
  }
  elsif ($db eq "tremblnew") {
    #$wgetz = 'http://www.embl-heidelberg.de/srs/srsc?' . "[$db-acc:$acc]|[$db-id:$id]";
    #$wgetz = 'http://www.embl-heidelberg.de/srs5bin/cgi-bin/wgetz?-e+' . "[$db-acc:$acc]|[$db-id:$id]";
    $wgetz = 'http://www.embl.de/srs5bin/cgi-bin/wgetz?-e+' . "[$db-id:$id]";
  }
  elsif ($db eq "pdb") {
    $wgetz = 'http://www.embl.de/srs5bin/cgi-bin/wgetz?-e+' . "[$db-id:$acc]";
    #$wgetz = 'http://www.embl-heidelberg.de/srs5bin/cgi-bin/wgetz?-e+' . "[pdbfinder-id:$acc]";
  }
  elsif ( $db eq "gp" || $db eq "gpnew" || $db eq "gbnew" ) {
    $wgetz = 'http://www3.ncbi.nlm.nih.gov/htbin-post/Entrez/query?db=s&form=6&dopt=d&uid=' . $acc;
  }
  elsif ($db eq "UniqGene") {
    $db = 'genbankest';
    #$wgetz = 'http://www.embl-heidelberg.de/srs5bin/cgi-bin/wgetz?-e+' . "[$db-id:$acc]";
    $id =~ s/Hs\.//;
    $wgetz = 'http://inhouse.ncbi.nlm.nih.gov/cgi-bin/UniGene/clust?ORG=Hs&CID=' .  $id;
  }

  $wgetz;
}

# 
# input  query length  and char
# output lines
#  
# p_scalar($query_length, ' ');
#
sub p_scalar {
  my ($length)= @_;

  # delete the comma
  $length =~ s/,//g;

  my $char = ' ';

  my ($line0,$line1) = ();
  # line width = 50 characters
  my $width = 50;

  # $length/$width -> how many segments?
  my $interval = int($length/5);

  my ($i,$j,$t,$rest,$irest);

  while ($interval % 10) {
    $interval++;
  }

  $interval = 1 if ($interval == 0 && $length < 10);

  $t = "0";
  do {
    $t += $interval;
    $i++;
  } while (($length-$t) >= $interval );
    
  $rest= $length - ($i * $interval);
  
  $j=$interval;

  # interval in $width
  $t = '';
  
  # rest in chars.
  $rest = int($rest*$width/$length);
  $width = $width-$rest;
   
  $t = int($width/$i);
  $irest = $width%$i;

  #$line0 = " " x 27 . "0";
  #$line1 = " " x 27 . '|';
  $line0 = " " x 24 . "0";
  $line1 = " " x 24 . '|';

  while ($i) {
    if ($irest) {
      $line0 .= "$char" x ($t + 1 - scalar @{[split('',$j)]}) . $j;
      $line1 .= " " x $t . '|';
      $irest--;
    }
    else {
      $line0 .= "$char" x ($t - scalar @{[split('',$j)]}) . $j;
      $line1 .= " " x ($t - 1) . '|';
    }
    $j += $interval;
    $i--;
  }
  
  if ($rest) {
    $line0 .= "$char" x $rest . "\n";
    $line1 .= " " x $rest .  '|' . $length . "\n";
  }
  else {
    $line0 .=  "\n";
    $line1 .=  $length . "\n";
  }
  #$line1 .= ' '. '_' x 50 . "\n";
  $line0 .= $line1;
  
  $line0;
}

###############################
# p_line($length,$start0,$stop0,$start1,$stop1,...)
#
sub p_line {
  my ($length,@segs) = @_;

  my $char = '_';
  my $outline;
  
  map s/,//g, $length, @segs;

  # test @segs;
  if (@segs) {
    if (($segs[1] - $segs[0]) > $length) {
      warn "$segs[1] - $segs[0] exceeds the length $length\n";
      exit 0;
    }
  }

  # line width = 50 characters
  my $width = 50;

  # $length/$width -> how many segments?
  my $interval = int($length/5);

  my ($i,$j,$t,$rest,$irest);

  while ($interval % 10) {
    $interval++;
  }

  $interval = 1 if ($interval == 0 && $length < 10);


  $t = 0;
  do {
    $t += $interval;
    $i++;
  } while (($length-$t) >= $interval );
    
  $rest= $length - ($i * $interval);
  
  $j=$interval;

  # interval in $width
  $t = '';
  
  # rest in chars.
  $rest = int($rest*$width/$length);
  my $iwidth = $width-$rest;
   
  $t = int($iwidth/$i);
  $irest = $iwidth%$i;

  $outline = " ";
    
  # firstly don't consider the irest problem

  my ($m,$irs,$irc);

  if ($#segs == 1) {
    if ($irest) {
      if ($segs[0] >= $t) {
	$irs = 1;
	$irc = 0;
      }
      elsif ($segs[1] > $t) {
	$irs = 0;
	$irc = 1;
      }
      $irest--;
    }

    $irc = 0 if ( ! $irc );
    $irs = 0 if ( ! $irs );

    # only one segment, the first one.    
    my $temp1 = int(($segs[1]-$segs[0])/$length*$width);
    if ( $temp1 <= 0 ) { 
      $temp1 = 1;
    }
    
    $outline .= ' ' x (int($segs[0]/$length*$width)+$irs) . "$char" x ($temp1 + $irc). "\n";
    ($irc, $irs) = ();
  }
  else {
    for $m (0..($#segs-1)) {
      
      if ($m == "0") {
	if ($irest) {
	  if ($segs[$m] >= $t) {
	    $irs = 1;
	    $irc = 0;
	    $t += $t;
	  }
	  elsif ($segs[$m+1] >= $t) {
	    $irs = 0;
	    $irc = 1;
	    
	    $t += $t;
	  }
	  $irest--;
	}

	$irc = 0 if ( ! $irc );
	$irs = 0 if ( ! $irs );

	my $temp2 = int(($segs[$m+1]-$segs[$m])/$length*$width);
	if ( $temp2 <= 0 ) { 
	  $temp2 = 1;
	}

	$outline .= ' ' x (int($segs[$m]/$length*$width)+$irs) . "$char" x ($temp2 + $irc);
      }
      elsif ( $m && !($m%2) ) {

	if ($irest) {
	  if ($segs[$m] >= $t) {
	    $irs = 1;
	    $irc = 0;
	    $t  += $t;
	  }
	  elsif ($segs[$m+1] >= $t) {
	    $irs = 0;
	    $irc = 1;
	    $t  += $t;
	  }
	  $irest--;
	}
	$irc = 0 if ( ! $irc );
	$irs = 0 if ( ! $irs );

	my $temp3 = int(($segs[$m+1]-$segs[$m])/$length*$width);
	if ( $temp3 <= 0 ) { 
	  $temp3 = 1;
	}

	$outline .= ' ' x (int(($segs[$m]-$segs[$m-1])/$length*$width)+$irs) . "$char" x ($temp3 + $irc);
      }
    }
    
    $outline .= "\n" if ( $outline !~ /\n$/ );
  }

  $outline;
}


__END__
